%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% COMMENTS & style %%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\wnsay}[1]{{{\color{blue}({\bf WN:} \textit{#1})}}}
\newcommand{\wnnay}[1]{}
\newcommand{\asay}[1]{{{\color{olive}({\bf A:} \textit{#1})}}}
\newcommand{\anay}[1]{}
\newcommand{\csay}[1]{{{\color{cyan}({\bf Chanh:} \textit{#1})}}}
\newcommand{\cnay}[1]{}
\newcommand{\lsay}[1]{{{\color{violet}({\bf Loc:} \textit{#1})}}}
\newcommand{\lnay}[1]{}
\newcommand{\tsay}[1]{{{\color{purple}({\bf Trung:} \textit{#1})}}}
\newcommand{\tnay}[1]{}

\newcommand{\doubt}[1]{{\color{red}{#1}}}
\def\TODO{\textsf{TODO}~}
%\newcommand{\todo}[1]{\TODO:{ \colorbox{green}{\bf(* #1 *)}}}
\newcommand{\todo}[1]{}

\newcommand{\btt}[1]{{\tt #1}}

\newcommand{\thead}[1]{\multicolumn{1}{|c|}{\textbf{#1}}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% FORMULAE & PROGRAM %%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\def\Prog{\ensuremath{\mathcal{P}}}
\def\nil{\btt{null}}
\def\cnil{\btt{NULL}}
\def\res{\btt{res}}
\def\new{\btt{new}}
\def\cskip{\ensuremath{\mathsf{skip}}}
\def\ccskip{skip}
\def\cpar{\|} %parallel composition

\newcommand{\myif}[3]{\btt{if}~(#1)~#2~\btt{else}~#3}
\newcommand{\mybind}[3]{\mytt{bind}~#1~\mytt{to}~#2~\mytt{in}~#3}

% \newcommand{\view}[2]{\ensuremath{#1{(}{#2}{)}}}
\newcommand{\self}{\btt{root}}

\newcommand{\unfold}{\btt{unfold}}
\newcommand{\fold}{\btt{fold}}
\newcommand{\freeEqn}{\btt{freeEqn}}
\newcommand{\letKW}{\btt{let}}
\newcommand{\splitKW}{\btt{split}}
\newcommand{\exKW}{{\bf ex}}
\newcommand{\XPure}{\btt{XPure}}
\newcommand{\IsData}{\btt{IsData}}
\newcommand{\IsPred}{\btt{IsPred}}

% second order variable
\def\hov{V}
\def\hovars{\hov}
\def\eqdef{\writeontop{=}{def}}
\def\defeq{\ensuremath{\,\triangleq}}
\def\veq{\ensuremath{\defeq}}
\def\pred{\btt{P}}
\def\heap{\ensuremath{\kappa}}
\def\constr{\ensuremath{\mathrm{\Phi}}}
\def\pre{\constr_{pr}}
\def\post{\constr_{po}}
\def\pure{\ensuremath{\pi}}
\def\St{\ensuremath{\mathrm{\Delta}}}
\def\D{\ensuremath{\St}}
\def\ptr{\ensuremath{\gamma}}
\def\inv{{\bf inv}}
\def\Inv{\btt{Inv}}
\def\df{\btt{df}}
\def\emp{\btt{emp}}
\def\true{\btt{true}}
\def\false{\btt{false}}
\def\arith{s}
\def\resid{\textit{S}}
\def\fresh{\btt{fresh}}
\def\const{k}
\def\bagconstr{\ensuremath{\varphi}}
\def\bag{{\cal B}}
\def\bagunion{\sqcup}
\def\bagintersect{\sqcap}
\def\bagsubsume {\sqsubset}
\def\bagsubtract{-}
\newcommand{\defpred}{\btt{pred}}
\newcommand{\vect}[1]{\overline{#1}}


\newcommand{\hformn}[3]{\ensuremath{{\btt{#1}}{\mapsto}{\btt{#2}}{\langle}{\btt{#3}}{\rangle}}}
\newcommand{\hform}[3]{\ensuremath{{#2}({#1,#3})}}
\newcommand{\node}[3]{\hformn{#1}{#2}{#3}}
\newcommand{\view}[2]{\ensuremath{\code{#1}{(}{\btt{#2}}{)}}}
\newcommand{\hformp}[3]{\ensuremath{{\btt{#2}}{\langle}{\btt{#1},\btt{#3}}{\rangle}}}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% PROOFS %%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\triple}[3]{\{ #1 \}~ {\color{blue}{#2}} ~\{ #3 \}}
\newcommand{\htriple}[3]{\ensuremath{\vdash
    \{#1\}\,{\color{blue}{#2}}\,\{#3\}}}
\newcommand{\htripleS}[3]{\ensuremath{\vdash
    {\color{blue}{#2}}}}    
\newcommand{\entailH}[3]{\ensuremath{#1{\vdash}#2\,{*}\,#3}}
\newcommand{\subtr}[3]{\entailH{#1}{#2}{#3}}
\newcommand{\writeontop}[2]{\mathrel{\stackrel{\makebox[0pt]{\mbox{\normalfont\tiny{#2}}}}{#1}}}
\newcommand{\equivtag}[1]{\writeontop{\equiv}{#1}}

\newcommand{\rulen}[1]{\ensuremath{{\bf \scriptstyle #1}}}
\newcommand{\srulen}[1]{{{\bf \scriptstyle \subeffect\text{-}}\rulen{#1}}}
\newcommand{\erulen}[1]{[\underline{\srulen{#1}}]}
\newcommand{\ebpverif}[2]{
  \ifthenelse{\equal{#1}{} }{
    \begin{prooftree}[rule style=simple] #2 \end{prooftree}
  }{
    \begin{prooftree}
      % \Hypo{\verirulen{#1}}
      \Hypo{[\underline{{\bf \scriptstyle }\rulen{#1}}]}
      \Infer[no rule]1{{\begin{prooftree}[rule style=simple] #2 \end{prooftree}}}
    \end{prooftree}
  }}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% MISC %%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\code}[1]{{\ensuremath{\tt #1}}}
\newcommand\figref[1]{Fig. \ref{#1}}
\newcommand\secref[1]{Sec. \ref{#1}}
\newcommand\subsecref[1]{Sub. \ref{#1}}
\newcommand\tabref[1]{Table \ref{#1}}
\newcommand{\hide}[1]{}
\newcommand{\hboxauto}[1]{         % hbox with autowidth
  \hbox{\begin{varwidth}{\textwidth} #1 \end{varwidth}}}
\newcommand{\sm}[1]{\mbox{$#1$}}

\def\sep{\code{*}}
\def\imply{\ensuremath{\Rightarrow}}

\newcommand{\infer}{\btt{infer}}
\newcommand{\ensures}{\btt{ensures}}
\newcommand{\requires}{\btt{requires}}
\newcommand{\hformone}[2]{\ensuremath{{\btt{#2}}{\langle}{\btt{#1}}{\rangle}}}
\newcommand{\anon}{\ensuremath{\_\,}}
\newcommand{\savespace}{\vspace{-2mm}}
\newcommand{\NI}{{\sm\scriptstyle \#}}
\newcommand{\form}[1]{\ensuremath{#1}}
\newcommand{\DP}{{\cal D}}
\newcommand{\implyeq}{\ensuremath{\equiv}}
\def\FV{\textit{FV}}
\newcommand{\prestate}[1]{\ensuremath{\phi_{#1}}}
\newcommand{\RA}{\ensuremath{\mathcal{R}}}
\newcommand{\infrule}[1]{[\underline{{\bf \scriptstyle INF-}\rulen{#1}}]}
\newcommand{\pstate}[1]{\ensuremath{\Delta_{#1}}}
\newcommand{\reldef}[1]{\ensuremath{\RA_{#1}}}
\newcommand{\unsat}[1]{\bf \footnotesize{\scriptstyle{UNSAT}}(\ensuremath{#1})}
\newcommand{\atomic}[1]{\ensuremath{\alpha_{#1}}}
\newcommand{\inferS}[6]{\ensuremath{[#1]~{#2}~{\vdash}~ #3 ~{\leadsto}~ (#5,#4,#6)}}
\newcommand{\heappred}{heaps}
\newcommand{\UNK}{U}
\newcommand{\FIL}[2]{\ensuremath{{\bigtriangledown}(#1,#2)}}
\newcommand{\horn}{\mathcal{A}}
\newcommand{\guard}{\ensuremath{\,\mid\,}}
\newcommand{\hoareN}[3]{\ensuremath{{\vdash}~\{#1\}~{#2}~\{#3\}}}
\newcommand{\hoareI}[6]{\ensuremath{[#1]~{\vdash}~\{#2\}~{#3}~\{#4,#5,#6\}}}
\newcommand{\defs}{\ensuremath{\overset{\textit{def}}{=}}}
\newcommand{\pstateN}{\ensuremath{\Delta}}
\newcommand{\myit}[1]{\textit{#1}}
\newcommand{\defprog}{\myit{Prog}}
\newcommand{\entailIKV}[8]{\ensuremath{[#1]~#2~{\vdash}\,{#5}\,{\leadsto}\,(#6,#7,#8)}}
\def\nochange{\myit{nochange}}
\newcommand{\fixcalc}{{\sc{FixCalc}~}}
\newcommand{\fixbag}{{\sc{FixBag}~}}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% listing style %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\def\commentcolor{purple!40!black}
\newcommand{\codecomment}[1]{\color{\commentcolor}{#1}}

\lstdefinestyle{customc}{
  belowcaptionskip=1\baselineskip,
  breaklines=true,
  % frame=L,
  % xleftmargin=\parindent,
  language=C,
  numbers=left,
  showstringspaces=false,
  basicstyle=\footnotesize\ttfamily,
  keywordstyle=\bfseries\color{green!40!black},
  % commentstyle=\itshape\color{purple!40!black},
  commentstyle=\itshape\color{\commentcolor},
  % identifierstyle=\color{blue},
  identifierstyle=\color{black},
  stringstyle=\color{orange},
}

\lstdefinestyle{informal}{
  belowcaptionskip=1\baselineskip,
  breaklines=true,
  % frame=L,
  % xleftmargin=\parindent,
  showstringspaces=false,
  basicstyle=\footnotesize\ttfamily\color{blue},
  keywordstyle=\bfseries\color{blue},
  commentstyle=\itshape\color{blue},
  identifierstyle=\color{blue},
  stringstyle=\color{blue},
}

\lstset{escapechar=@,style=customc}


\newcommand{\rulename}[1]{\ensuremath{{\bf \scriptstyle #1}}}
\newcommand{\rulesidecond}[1]{{\footnotesize{$\mkern-5mu#1$}}}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "main"
%%% End:
